using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace dipl_rad_1589
{
	/// <summary>
	/// Form1 je sredisnji dio programa. Ovdje se instanciraju objekti klasa Solver, Visualizer, 
	/// FormDimenzije, Form Postavke, FormSnimanje i ostali potrebni
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;
		private System.Windows.Forms.RadioButton radioButton3;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.RadioButton radioButton4;
		private System.Windows.Forms.RadioButton radioButton5;
		private System.Windows.Forms.RadioButton radioButton6;
		private System.Windows.Forms.RadioButton radioButton7;
		private System.Windows.Forms.NumericUpDown numericUpDown1;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.StatusBarPanel statusBarPanel1;
		private System.Windows.Forms.StatusBarPanel statusBarPanel2;
		private System.Windows.Forms.StatusBarPanel statusBarPanel3;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.RadioButton radioButton8;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.Button button5;

		/// <summary>
		/// Varijable potrebne za odreene metode iz upotrebljavanih klasa
		/// </summary>		
		private int[,] obstacleMap = new int[512, 512];
		private int[] dimenzije = new int[2];	// dimenzije sustava
		private int tileType = 1;				// 0 - fluid, 1 - prepreka, 2 - utok, 3 - istok
		public int visType = 1;					// 0 - tlak, 1 - brzine, 2 - vektori brzina, 3 - strujnice
		
		public string imeDatoteke;
		public System.Drawing.Imaging.ImageFormat formatDatoteke;
		private int ucestalostSnimanja = -1;

		Visualizer vis;
		Solver solv;

		public Form1()
		{			
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.statusBarPanel1 = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanel2 = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanel3 = new System.Windows.Forms.StatusBarPanel();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.radioButton8 = new System.Windows.Forms.RadioButton();
			this.radioButton3 = new System.Windows.Forms.RadioButton();
			this.radioButton2 = new System.Windows.Forms.RadioButton();
			this.radioButton1 = new System.Windows.Forms.RadioButton();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.radioButton7 = new System.Windows.Forms.RadioButton();
			this.radioButton6 = new System.Windows.Forms.RadioButton();
			this.radioButton5 = new System.Windows.Forms.RadioButton();
			this.radioButton4 = new System.Windows.Forms.RadioButton();
			this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.button4 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel3)).BeginInit();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
			this.groupBox3.SuspendLayout();
			this.SuspendLayout();
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 571);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.statusBarPanel1,
																						  this.statusBarPanel2,
																						  this.statusBarPanel3});
			this.statusBar1.ShowPanels = true;
			this.statusBar1.Size = new System.Drawing.Size(792, 22);
			this.statusBar1.TabIndex = 0;
			this.statusBar1.Text = "statusBar1";
			// 
			// statusBarPanel1
			// 
			this.statusBarPanel1.Text = "Spreman";
			this.statusBarPanel1.Width = 200;
			// 
			// statusBarPanel2
			// 
			this.statusBarPanel2.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarPanel2.Width = 465;
			// 
			// statusBarPanel3
			// 
			this.statusBarPanel3.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.statusBarPanel3.Text = "Diplomski rad 1589";
			this.statusBarPanel3.Width = 111;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem7,
																					  this.menuItem10});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem5,
																					  this.menuItem6});
			this.menuItem1.Text = "Projekt";
			// 
			// menuItem2
			// 
			this.menuItem2.Enabled = false;
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "Novi projekt";
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "Otvori...";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 2;
			this.menuItem5.Text = "Snimi kao...";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 3;
			this.menuItem6.Text = "Izai iz programa";
			this.menuItem6.Click += new System.EventHandler(this.menuItem6_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 1;
			this.menuItem7.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem8,
																					  this.menuItem4});
			this.menuItem7.Text = "Postavke";
			// 
			// menuItem8
			// 
			this.menuItem8.Enabled = false;
			this.menuItem8.Index = 0;
			this.menuItem8.Text = "Osnovne postavke";
			this.menuItem8.Click += new System.EventHandler(this.menuItem8_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 1;
			this.menuItem4.Text = "Pohrana rezultata";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click_1);
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 2;
			this.menuItem10.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuItem11,
																					   this.menuItem12});
			this.menuItem10.Text = "Pomo";
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 0;
			this.menuItem11.Text = "Upute";
			this.menuItem11.Click += new System.EventHandler(this.menuItem11_Click);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 1;
			this.menuItem12.Text = "O programu";
			this.menuItem12.Click += new System.EventHandler(this.menuItem12_Click);
			// 
			// pictureBox1
			// 
			this.pictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pictureBox1.Location = new System.Drawing.Point(8, 5);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(627, 523);
			this.pictureBox1.TabIndex = 2;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseMove);
			this.pictureBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseDown);
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button1.Location = new System.Drawing.Point(656, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(120, 23);
			this.button1.TabIndex = 3;
			this.button1.Text = "Inic. mreu";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button2.Location = new System.Drawing.Point(656, 40);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(120, 23);
			this.button2.TabIndex = 4;
			this.button2.Text = "Prikai mreu";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button3.Enabled = false;
			this.button3.Location = new System.Drawing.Point(656, 528);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(120, 23);
			this.button3.TabIndex = 5;
			this.button3.Text = "Raunaj";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Controls.Add(this.radioButton8);
			this.groupBox1.Controls.Add(this.radioButton3);
			this.groupBox1.Controls.Add(this.radioButton2);
			this.groupBox1.Controls.Add(this.radioButton1);
			this.groupBox1.Enabled = false;
			this.groupBox1.Location = new System.Drawing.Point(656, 72);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(120, 120);
			this.groupBox1.TabIndex = 6;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Odabir elementa";
			// 
			// radioButton8
			// 
			this.radioButton8.Location = new System.Drawing.Point(8, 88);
			this.radioButton8.Name = "radioButton8";
			this.radioButton8.TabIndex = 3;
			this.radioButton8.Text = "Klizei zid";
			this.radioButton8.CheckedChanged += new System.EventHandler(this.radioButton8_CheckedChanged);
			// 
			// radioButton3
			// 
			this.radioButton3.Location = new System.Drawing.Point(8, 64);
			this.radioButton3.Name = "radioButton3";
			this.radioButton3.TabIndex = 2;
			this.radioButton3.Text = "Istok";
			this.radioButton3.CheckedChanged += new System.EventHandler(this.radioButton3_CheckedChanged);
			// 
			// radioButton2
			// 
			this.radioButton2.Location = new System.Drawing.Point(8, 40);
			this.radioButton2.Name = "radioButton2";
			this.radioButton2.TabIndex = 1;
			this.radioButton2.Text = "Utok";
			this.radioButton2.CheckedChanged += new System.EventHandler(this.radioButton2_CheckedChanged);
			// 
			// radioButton1
			// 
			this.radioButton1.Checked = true;
			this.radioButton1.Location = new System.Drawing.Point(8, 16);
			this.radioButton1.Name = "radioButton1";
			this.radioButton1.TabIndex = 0;
			this.radioButton1.TabStop = true;
			this.radioButton1.Text = "Prepreka";
			this.radioButton1.CheckedChanged += new System.EventHandler(this.radioButton1_CheckedChanged);
			// 
			// groupBox2
			// 
			this.groupBox2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox2.Controls.Add(this.checkBox1);
			this.groupBox2.Controls.Add(this.radioButton7);
			this.groupBox2.Controls.Add(this.radioButton6);
			this.groupBox2.Controls.Add(this.radioButton5);
			this.groupBox2.Controls.Add(this.radioButton4);
			this.groupBox2.Enabled = false;
			this.groupBox2.Location = new System.Drawing.Point(656, 200);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(120, 160);
			this.groupBox2.TabIndex = 7;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Vizualizacija";
			// 
			// checkBox1
			// 
			this.checkBox1.Checked = true;
			this.checkBox1.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBox1.Location = new System.Drawing.Point(8, 128);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.TabIndex = 4;
			this.checkBox1.Text = "Prikaz mree";
			// 
			// radioButton7
			// 
			this.radioButton7.Location = new System.Drawing.Point(8, 88);
			this.radioButton7.Name = "radioButton7";
			this.radioButton7.TabIndex = 3;
			this.radioButton7.Text = "Strujnice";
			this.radioButton7.CheckedChanged += new System.EventHandler(this.radioButton7_CheckedChanged);
			// 
			// radioButton6
			// 
			this.radioButton6.Location = new System.Drawing.Point(8, 64);
			this.radioButton6.Name = "radioButton6";
			this.radioButton6.TabIndex = 2;
			this.radioButton6.Text = "Vektori brzina";
			this.radioButton6.CheckedChanged += new System.EventHandler(this.radioButton6_CheckedChanged);
			// 
			// radioButton5
			// 
			this.radioButton5.Checked = true;
			this.radioButton5.Location = new System.Drawing.Point(8, 40);
			this.radioButton5.Name = "radioButton5";
			this.radioButton5.TabIndex = 1;
			this.radioButton5.TabStop = true;
			this.radioButton5.Text = "Brzine";
			this.radioButton5.CheckedChanged += new System.EventHandler(this.radioButton5_CheckedChanged);
			// 
			// radioButton4
			// 
			this.radioButton4.Location = new System.Drawing.Point(8, 16);
			this.radioButton4.Name = "radioButton4";
			this.radioButton4.TabIndex = 0;
			this.radioButton4.Text = "Tlak";
			this.radioButton4.CheckedChanged += new System.EventHandler(this.radioButton4_CheckedChanged);
			// 
			// numericUpDown1
			// 
			this.numericUpDown1.Location = new System.Drawing.Point(32, 40);
			this.numericUpDown1.Maximum = new System.Decimal(new int[] {
																		   10000,
																		   0,
																		   0,
																		   0});
			this.numericUpDown1.Minimum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   0});
			this.numericUpDown1.Name = "numericUpDown1";
			this.numericUpDown1.Size = new System.Drawing.Size(56, 20);
			this.numericUpDown1.TabIndex = 8;
			this.numericUpDown1.Value = new System.Decimal(new int[] {
																		 1,
																		 0,
																		 0,
																		 0});
			// 
			// groupBox3
			// 
			this.groupBox3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox3.Controls.Add(this.numericUpDown1);
			this.groupBox3.Enabled = false;
			this.groupBox3.Location = new System.Drawing.Point(656, 440);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(120, 80);
			this.groupBox3.TabIndex = 9;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Broj koraka po prikazu";
			// 
			// button4
			// 
			this.button4.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button4.Enabled = false;
			this.button4.Location = new System.Drawing.Point(656, 368);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(120, 23);
			this.button4.TabIndex = 10;
			this.button4.Text = "Prikai";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// button5
			// 
			this.button5.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button5.Location = new System.Drawing.Point(656, 400);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(120, 23);
			this.button5.TabIndex = 11;
			this.button5.Text = "Sauvaj";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(792, 593);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.button5);
			this.Controls.Add(this.button4);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.groupBox2);
			this.Menu = this.mainMenu1;
			this.MinimumSize = new System.Drawing.Size(800, 640);
			this.Name = "Form1";
			this.Text = "Animacija fluida u okruenju s preprekama";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel3)).EndInit();
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
			this.groupBox3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		/// <summary>
		/// Klikom na button1 otvara se novi prozor u kojem se mogu unijeti dimenzije simuliranoga sustava.
		/// Defaultna vrijednost je 40x40.
		/// </summary>
		private void button1_Click(object sender, System.EventArgs e)
		{
			FormDimenzije newForm = new FormDimenzije(dimenzije);

			// Prikazi novi prozor i nakon povratka ga odmah unisti
			newForm.ShowDialog();
			newForm.Dispose();
            
			// Instanciraj objekte klasa Solver i Visualizer sa zadanim dimenzijama
			solv = new Solver(dimenzije[0], dimenzije[1]);
			vis = new Visualizer(pictureBox1, dimenzije[0], dimenzije[1], solv);

			// Nakon sto sustav postoji, omoguci izvrsavanje proracuna na njemu
			button2.Enabled = true;
			button3.Enabled = true;
			button4.Enabled = true;
			groupBox1.Enabled = true;
			groupBox2.Enabled = true;
			groupBox3.Enabled = true;
			menuItem8.Enabled = true;
		}

		/// <summary>
		/// Klikom na button2 dobija se vizualizacija prepreka bez trenutnog stanja sustava. Moze se
		/// koristiti u slucaju da tijekom simulacije treba mijenjati prepreke
		/// </summary>
		private void button2_Click(object sender, System.EventArgs e)
		{
			vis.obstacleVisualization(obstacleMap, true);
			pictureBox1.Invalidate();
		}

		/// <summary>
		/// Lijevom tipkom misa mogu se dodavati prepreke, utoci i istoci i pomicni zidovi. 
		/// Desnom se odredeni element vraca u stanje 0 (ispunjen fluidom)
		/// </summary>
		private void pictureBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (vis != null) 
			{
				if (e.X < vis.offsetX || e.Y < vis.offsetY)
					return;
				if (e.X > (vis.offsetX + vis.problemWidth * vis.zoom) || e.Y > (vis.offsetY + vis.problemHeight * vis.zoom))
					return;

				switch (e.Button) 
				{
					case System.Windows.Forms.MouseButtons.None:
						return;
					case System.Windows.Forms.MouseButtons.Left:
						obstacleMap[(int)((e.X - vis.offsetX) / vis.zoom), (int)((e.Y - vis.offsetY) / vis.zoom)] = tileType;
						break;
					case System.Windows.Forms.MouseButtons.Right:
						obstacleMap[(int)((e.X - vis.offsetX) / vis.zoom), (int)((e.Y - vis.offsetY) / vis.zoom)] = 0;
						break;
				}

				vis.obstacleVisualization(obstacleMap, true);
				pictureBox1.Invalidate();
			}
		}

		private void pictureBox1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (vis != null) 
			{
				if (e.X < vis.offsetX || e.Y < vis.offsetY)
					return;
				if (e.X > (vis.offsetX + vis.problemWidth * vis.zoom) || e.Y > (vis.offsetY + vis.problemHeight * vis.zoom))
					return;

				switch (e.Button) 
				{
					case System.Windows.Forms.MouseButtons.None:
						return;
					case System.Windows.Forms.MouseButtons.Left:
						obstacleMap[(int)((e.X - vis.offsetX) / vis.zoom), (int)((e.Y - vis.offsetY) / vis.zoom)] = tileType;
						break;
					case System.Windows.Forms.MouseButtons.Right:
						obstacleMap[(int)((e.X - vis.offsetX) / vis.zoom), (int)((e.Y - vis.offsetY) / vis.zoom)] = 0;
						break;
				}

				vis.obstacleVisualization(obstacleMap, true);
				pictureBox1.Invalidate();
			}
		}

		/// <summary>
		/// Glavna metoda za izracun jednog koraka simulacije
		/// </summary>
		private void button3_Click(object sender, System.EventArgs e)
		{
			// Postavi prepreke kako su iscrtane
			solv.setObstacles(obstacleMap);
			solv.setBoundaries();

			statusBarPanel1.Text = "Raunanje u tijeku...";

			// Odradi zadani broj iteracija algoritma i snimaj rezultate u datoteke ako je tako odabrano
			for (int i = 0; i < numericUpDown1.Value; i++) 
			{
				statusBarPanel2.Text = "U tijeku: " + (i + 1) + " / " + numericUpDown1.Value.ToString();

				// Napreduj jedan korak
				solv.advanceTimeStep();

				// Ako je odabrano snimanje rezultata, snimi podatke u datoteku zadanog imena s dodatkom rednog broja 
				// koraka i odabranog formata
				if (ucestalostSnimanja != -1 && i % ucestalostSnimanja == 0) 
				{
					drawPicBox();
					try
					{
						pictureBox1.Image.Save(imeDatoteke + (1000 + i) + "." + formatDatoteke.ToString(), formatDatoteke);
					}
					catch{}
				}
			}

			statusBarPanel2.Text = "";

			// Na kraju koraka prikazi rezultate
			drawPicBox();
		}

		/// <summary>
		/// Iscrtavanje rezultata simulacije. Uzima u obzir stanje radiobutton-a koji odreduju nacin iscrtavanja.
		/// </summary>
		private void drawPicBox () 
		{
			statusBarPanel1.Text = "Iscrtavanje u tijeku...";
			
			// Iscrtavanje tlaka
			if (radioButton4.Checked == true) 
			{
				vis.drawPressure();
				if (checkBox1.Checked)
					vis.drawGrid();
			}
			//Iscrtavanje brzina (defaultno odabrano iscrtavanje obje komponente)
			if (radioButton5.Checked == true) 
			{
				vis.drawVelocities(true, true);
				if (checkBox1.Checked)
					vis.drawGrid();
			}
			// Iscrtavanje vektora brzina
			if (radioButton6.Checked == true) 
			{
				vis.drawStreamlines();
			}
			// Iscrtavanje strujnica
			if (radioButton7.Checked == true) 
			{
				vis.drawStreams();
			}

			// Postavi pictureBox1 u red za ponovno iscrtavanje
			pictureBox1.Invalidate();

			statusBarPanel1.Text = "Spreman";
		}

		// Odabrano dodavanje prepreka - lijeva tipka misa ce doadavati prepreke
		private void radioButton1_CheckedChanged(object sender, System.EventArgs e)
		{
			if (radioButton1.Checked == true)
				tileType = 1;
		}

		// Odabrano dodavanje utoka - lijeva tipka misa ce doadavati utoka
		private void radioButton2_CheckedChanged(object sender, System.EventArgs e)
		{
			if (radioButton2.Checked == true)
				tileType = 2;
		}

		// Odabrano dodavanje istoka - lijeva tipka misa ce doadavati istok
		private void radioButton3_CheckedChanged(object sender, System.EventArgs e)
		{
			if (radioButton3.Checked == true)
				tileType = 3;
		}

		//  Odabrano dodavanje pomicnog zida - lijeva tipka misa ce dodavati pomicni zid
		private void radioButton8_CheckedChanged(object sender, System.EventArgs e)
		{
			if (radioButton8.Checked == true)
				tileType = 4;
		}

		// Main menu -> Pomoc -> O programu
		private void menuItem12_Click(object sender, System.EventArgs e)
		{
			System.Windows.Forms.MessageBox.Show("Ovaj program je izraen kao dio diplomskog rada br. 1589 na\nFakultetu elektrotehnike i raunarstva Sveuilita u Zagrebu.\n\nZoran Dropi, lipanj 2006.", "O programu", System.Windows.Forms.MessageBoxButtons.OK);
		}

		// Main menu -> Projekt -> Izadi iz programa
		private void menuItem6_Click(object sender, System.EventArgs e)
		{
			Application.Exit();		
		}

		// Main menu -> Pomoc -> Upute za koristenje
		private void menuItem11_Click(object sender, System.EventArgs e)
		{
			System.Windows.Forms.MessageBox.Show("Program funkcionira u tri glavna koraka:\n\n1. Kliknite \"Inic. mree\" za biranje veliine mree\n\n2. Odaberite tip elementa i kliknite na njega da biste ga postavili \n\n3. Odaberite vrstu prikaza i brzinu napredovanja simulacije\nu odnosu na vizualizaciju i kliknite \"Raunaj\"", "Upute za koritenje", System.Windows.Forms.MessageBoxButtons.OK);
		}

		/// <summary>
		/// Promjena velicine glavnog prozora. Prilagodava se pozicija svih elemenata i velicina pictureBox-a.
		/// </summary>
		private void Form1_Resize(object sender, System.EventArgs e)
		{
			pictureBox1.Size = new Size(groupBox1.Left - (this.Width - groupBox1.Right) - pictureBox1.Left, statusBar1.Top - 2 * pictureBox1.Top);

			if (pictureBox1.Width == 0)
				return;

			if (vis != null) 
			{
				vis.canvasSizeChange(pictureBox1);
				vis.obstacleVisualization(obstacleMap, true);
				pictureBox1.Invalidate();
			}

			statusBarPanel2.Text = "PictureBox: " + pictureBox1.Width + " x " + pictureBox1.Height;
		}

		// Main menu -> Projekt - > Otvori projekt
		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			// Otvori fileDialog gdje korisnik moze odabrati odredenu datoteku
			openFileDialog1.ShowDialog();

			try 
			{
				// Otvori odabranu datoteku za pisanje
				System.IO.BinaryReader proj = new System.IO.BinaryReader(openFileDialog1.OpenFile());
			
				// S pocetka datoteke procitaj dimenzije sustava
				dimenzije[0] = proj.ReadInt32();
				dimenzije[1] = proj.ReadInt32();

				// Procitaj podatke o preprekama
				for (int i = 0; i < dimenzije[0]; i++) 
				{
					for (int j = 0; j < dimenzije[1]; j++) 
					{
						obstacleMap[i, j] = proj.ReadInt32();
					}
				}

				// Zatvori datoteku
				proj.Close();
			}
			catch 
			{
				// Ako bilo koji korak nije uspio, jednostavno odustani
				return;
			}

			// Instanciraj novi Solver i Vizualizer procitanih dimenzija dimenzija
			solv = new Solver(dimenzije[0], dimenzije[1]);
			vis = new Visualizer(pictureBox1, dimenzije[0], dimenzije[1], solv);

			// Omoguci koristenje kontrola za upravljanje simulacijom
			button2.Enabled = true;
			button3.Enabled = true;
			button4.Enabled = true;
			groupBox1.Enabled = true;
			groupBox2.Enabled = true;
			groupBox3.Enabled = true;
			menuItem8.Enabled = true;
		}

		// Main menu -> Projekt - > Snimi projekt
		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			System.IO.BinaryWriter proj;
			
			// Otvori fileDialog gdje korisnik moze odabrati datoteku
			saveFileDialog1.ShowDialog();

			try
			{
				// Otvori odabranu datoteku. Zapisivanje u nju ce unistiti postojece podatke.
				proj = new System.IO.BinaryWriter(saveFileDialog1.OpenFile());
			}
			catch 
			{
				// ko otvaranje nije uspjelo, jednostavno odustani
				System.Windows.Forms.MessageBox.Show("Greka pri otvaranju datoteke. Mapa nije sauvana.", "Greka", MessageBoxButtons.OK);
				return;
			}

			// Na pocetak datoteke zapisi dimenzije sustava
			proj.Write(dimenzije[0]);
			proj.Write(dimenzije[1]);

			// Zapisi podatke o preprekama
			for (int i = 0; i < dimenzije[0]; i++) 
			{
				for (int j = 0; j < dimenzije[1]; j++) 
				{
					proj.Write(obstacleMap[i, j]);
				}
			}

			// Zatvori datoteku
			proj.Close();
		}

		// Main menu -> Postavke -> Promijeni
		private void menuItem8_Click(object sender, System.EventArgs e)
		{
			FormPostavke newForm = new FormPostavke(solv);

			newForm.ShowDialog();
			newForm.Dispose();
		}

		// Iscrtavanje bez vremenskog napredovanja u simulaciji
		private void button4_Click(object sender, System.EventArgs e)
		{
			drawPicBox();
		}

		// Odabran je nacin iscrtavanja koji podrzava iscrtavanje grida
		private void radioButton4_CheckedChanged(object sender, System.EventArgs e)
		{
			checkBox1.Enabled = true;
		}

		// Odabran je nacin iscrtavanja koji podrzava iscrtavanje grida
		private void radioButton5_CheckedChanged(object sender, System.EventArgs e)
		{
			checkBox1.Enabled = true;
		}

		// Odabran je nacin iscrtavanja koji ne podrzava iscrtavanje grida
		private void radioButton6_CheckedChanged(object sender, System.EventArgs e)
		{
			checkBox1.Enabled = false;
		}

		// Odabran je nacin iscrtavanja koji ne podrzava iscrtavanje grida
		private void radioButton7_CheckedChanged(object sender, System.EventArgs e)
		{
			checkBox1.Enabled = false;
		}

		// Main menu -> Postavke -> Pohrana rezultata
		private void menuItem4_Click_1(object sender, System.EventArgs e)
		{
			FormSnimanje newForm = new FormSnimanje();

			newForm.ShowDialog();

			imeDatoteke = newForm.imeDatoteke;
			formatDatoteke = newForm.formatSlike;
			ucestalostSnimanja = newForm.ucestalost;

			newForm.Dispose();
		}

		// Snimanje cetiri uzastopne slike sa sva cetiri nacina prikaza bez vremenskog napredovanja simulacije
		private void button5_Click(object sender, System.EventArgs e)
		{
			FormSnimanje newForm = new FormSnimanje();

			newForm.groupBox3.Enabled = false;

			newForm.ShowDialog();

			try 
			{
				// Iscrtaj i sacuvaj vizualizaciju tlaka
				vis.drawPressure();
				pictureBox1.Image.Save(newForm.imeDatoteke + "pressure." + newForm.formatSlike.ToString(), newForm.formatSlike);

				// Iscrtaj i sacuvaj vizualizaciju brzina
				vis.drawVelocities(true, true);
				pictureBox1.Image.Save(newForm.imeDatoteke + "velocities." + newForm.formatSlike.ToString(), newForm.formatSlike);

				// Iscrtaj i sacuvaj vizualizaciju vektora brzina
				vis.drawStreamlines();
				pictureBox1.Image.Save(newForm.imeDatoteke + "streamlines." + newForm.formatSlike.ToString(), newForm.formatSlike);

				// Iscrtaj i sacuvaj vizualizaciju strujnica
				vis.drawStreams();
				pictureBox1.Image.Save(newForm.imeDatoteke + "streams." + newForm.formatSlike.ToString(), newForm.formatSlike);
			}
			catch {}

			newForm.Dispose();
		}
	}
}
